config/routes.rb
Rails.application.routes.draw do
  devise_for :cuentas, :skip => [:sessions]
  as :cuenta do
    get 'iniciarsesion', to: 'devise/sessions#new', as: :new_cuenta_session
    post 'iniciarsesion', to: 'devise/sessions#create', as: :cuenta_session
    delete 'cerrarsesion', to: 'devise/sessions#destroy', as: :destroy_cuenta_session
    
    get 'cambiarcontrasenia', to: 'mi_cuenta/contrasenia#edit', as: :cambiar_contrasenia
    patch 'cambiarcontrasenia', to: 'mi_cuenta/contrasenia#update'
    put 'cambiarcontrasenia', to: 'mi_cuenta/contrasenia#update'
  end
  
  resources :inscripciones, only: [:new, :create]
  
  get 'mostrar_categoria', to: 'inscripciones#mostrar_categoria', as: 'mostrar_categoria'
  get 'mostrar_categoria/:nil/:discapacidad/:silla_ruedas', to: 'inscripciones#mostrar_categoria'
  get 'mostrar_categoria/:nil/:nil1/:discapacidad/:silla_ruedas', to: 'inscripciones#mostrar_categoria'
  get 'mostrar_categoria/:dia/:mes/:anio/:discapacidad/:silla_ruedas', to: 'inscripciones#mostrar_categoria'
  
  get 'tipo_transaccion', to: 'inscripciones#mostrar_categoria', as: 'tipo_transaccion'
  get 'tipo_transaccion/:tipo', to: 'inscripciones#tipo_transaccion'
  
  resources :contenido, :sistema, only: [:index]
  
  resources :inscritos, only: [:index] do
    resources :comprobantes, only: [:new, :create, :update, :show]
  end
  
  get 'mostrar_numero', to: 'comprobantes#mostrar_numero', as: 'mostrar_numero'
  get 'mostrar_numero/:elite', to: 'comprobantes#mostrar_numero'
  
  namespace :contenido do
    resources :posts, :archivos, :bloques, only: [:index, :new, :create, :edit, :update]
    resources :menus, only: [:index] do
      resources :elementos, only: [:new, :create, :edit, :update]
    end
  end
  
  namespace :sistema do
    resources :cuentas, :roles, only: [:index, :new, :create, :edit, :update]
  end
  
  get 'post/:id', controller: 'inicio', action: 'post', as: :post
  
  get 'archivo/:id', controller: 'inicio', action: 'archivo', as: :archivo
  
  get 'u/:usuario', controller: 'inicio', action: 'perfil', as: :perfil
  get 'u/:usuario/pag/:pag', controller: 'inicio', action: 'perfil'
  
  get 'pag/:pag', controller: 'inicio', action: 'index', as: :index_pag
  
  get 'etiqueta/:consulta', controller: 'inicio', action: 'etiqueta', as: :etiqueta
  get 'etiqueta/:consulta/pag/:pag', controller: 'inicio', action: 'etiqueta'
  
  get '/:alias', controller: 'inicio', action: 'alias', as: :alias
  get '/:alias/pag/:pag', controller: 'inicio', action: 'alias'
  
  root 'inicio#index'
  
  # Example of regular route:
  #   get 'products/:id' => 'catalog#view'

  # Example of named route that can be invoked with purchase_url(id: product.id)
  #   get 'products/:id/purchase' => 'catalog#purchase', as: :purchase

  # Example resource route (maps HTTP verbs to controller actions automatically):
  #   resources :products

  # Example resource route with options:
  #   resources :products do
  #     member do
  #       get 'short'
  #       post 'toggle'
  #     end
  #
  #     collection do
  #       get 'sold'
  #     end
  #   end

  # Example resource route with sub-resources:
  #   resources :products do
  #     resources :comments, :sales
  #     resource :seller
  #   end

  # Example resource route with more complex sub-resources:
  #   resources :products do
  #     resources :comments
  #     resources :sales do
  #       get 'recent', on: :collection
  #     end
  #   end

  # Example resource route with concerns:
  #   concern :toggleable do
  #     post 'toggle'
  #   end
  #   resources :posts, concerns: :toggleable
  #   resources :photos, concerns: :toggleable

  # Example resource route within a namespace:
  #   namespace :admin do
  #     # Directs /admin/products/* to Admin::ProductsController
  #     # (app/controllers/admin/products_controller.rb)
  #     resources :products
  #   end
end

app/models/bloque.rb
class Bloque
  include Mongoid::Base
  
  attr_accessor :ent_archivos
  
  field :ubicacion, type: String # sup: Superior, izq: Izquierdo, der: Derecho, inf: Inferior
  
  field :titulo, type: String
  field :mostrar_titulo, type: Boolean
  
  field :contenido, type: String
  
  embeds_many :archivos_adjuntos, class_name: 'Embed::ArchivoAdjunto'

  field :publicado, type: Boolean
  field :fecha_publicado, type: DateTime
  
  field :transparente, type: Boolean
  
  field :posicion, type: Integer, default: 0

  validates_presence_of :ubicacion
  validates_presence_of :titulo
  validates_presence_of :contenido
  
  before_create :insertar_datos
  
  after_initialize :para_editar
  
  before_update :actualizar_datos
  
  protected
  
  def para_editar
    if self.archivos_adjuntos && self.archivos_adjuntos.any?
      self.ent_archivos=[]
      self.archivos_adjuntos.each do |obj_archivo|
        self.ent_archivos.push({ :id => obj_archivo.archivo_id, :file_name => obj_archivo.archivo.archivo_file_name, :value => obj_archivo.archivo_id })
      end
    end
  end
  
  def guardar_adjuntos
    self.archivos_adjuntos = []
    unless ent_archivos.nil? || ent_archivos.empty?
      ent_archivos.each do |archivo|
        if self.archivos_adjuntos.select{|i| i[:archivo_id] == BSON::ObjectId.from_string(archivo)}[0].nil? && query_archivo = Archivo.where(:_id => archivo).first
          self.archivos_adjuntos.push Embed::ArchivoAdjunto.new(:archivo => query_archivo)
        end
      end
    end
    
    # Busca archivos adjuntos dentro del contenido del bloque
    url = AppConfig.aplicacion.url.gsub(/[\/.]/,'/'=>'\\/','.'=>'[.]')
    pat = eval("/[\"']"+url+"\\/archivo\\/[0-9a-z]{24}[\"']|[\\/?\"']\\/archivo\\/[0-9a-z]{24}[\\/?\"']/i")
    self.contenido.scan(pat).each do |archivo|
      archivo = archivo[-25..-2]
      if self.archivos_adjuntos.select{|i| i[:archivo_id] == BSON::ObjectId.from_string(archivo)}[0].nil? && query_archivo = Archivo.where(:_id => archivo).first
        self.archivos_adjuntos.push Embed::ArchivoAdjunto.new(:archivo => query_archivo)
      end
    end
  end
  
  def insertar_datos
  
    guardar_adjuntos
    
    if self.publicado
      self.fecha_publicado = DateTime.now
    end
    
  end
  
  def actualizar_datos
    
    guardar_adjuntos
    
    if self.publicado && self.fecha_publicado.nil?
      self.fecha_publicado = DateTime.now
    end
    
  end
  
end

app/controllers/contenido/archivos_controller.rb
class Contenido::ArchivosController < ApplicationController
  
  before_action :authenticate_cuenta!
  before_action 'autenticar_permiso!("contenido","archivos")'
  
  def index
    render :locals => { :archivos => current_cuenta.persona.archivos.where(:borrado.exists => false).sort(:_id => -1) }
  end

  def new
    @archivo = Archivo.new
  end
  
  def create
    @archivo = Archivo.new({:archivo => params[:archivo], :tmp_vars => get_tmp_vars})
    if @archivo.save
      respond_with @archivo do |format|
        format.json {render :json => { _exito: true, _mensaje: 'archivo subido.', _archivo: @archivo, _campo_id: params[:campo_id], _tmp_id: params[:tmp_id], _edit_url: edit_contenido_archivo_path(@archivo._id) } }
      end
    else
      respond_with @archivo do |format|
        format.json {render :json => { _exito: false, _mensaje: @archivo.errors[:archivo], _campo_id: params[:campo_id], _tmp_id: params[:tmp_id] } }
      end
    end
  end
  
  def edit
    @archivo = current_cuenta.persona.archivos.where(:_id => params[:id],:borrado.exists => false).first
  end
  
  def update
    @archivo = current_cuenta.persona.archivos.where(:_id => params[:id],:borrado.exists => false).first
    @archivo.tmp_vars = get_tmp_vars
    if params[:archivo][:borrado] != '1'
      params[:archivo].delete(:borrado)
    end
    if @archivo.update_attributes(params[:archivo])
      respond_with @archivo do |format|
        format.json {render :json => { _exito: true, _mensaje: 'Archivo editado exitosamente.', _ubicacion: contenido_archivos_path } }
      end
    else
      campos={}
      @archivo.errors.each do |error|
        campos[error]={_set: {error: @archivo.errors[error]} }
      end
      respond_with @archivo do |format|
        format.json {render :json => { _exito: false, _canterrores: @archivo.errors.count, _campos: campos} }
      end
    end
  end
  
end

app/controllers/contenido/bloques_controller.rb
class Contenido::BloquesController < ApplicationController
  
  before_action :authenticate_cuenta!
  before_action 'autenticar_permiso!("contenido","bloques")'
  
  def index
    render :locals => { :bloques => Bloque.where( :borrado.exists => false).sort(:_id => -1) }
  end
  
  def new
    @bloque = Bloque.new
  end
  
  def create
    if params[:bloque][:publicado] != '1'
      params[:bloque].delete(:publicado)
    end
    @bloque = Bloque.new(params[:bloque].merge( :tmp_vars => get_tmp_vars))
    if @bloque.save
      respond_with @bloque do |format|
        format.json {render :json => { _exito: true, _mensaje: 'Bloque subido exitosamente.', _ubicacion: contenido_bloques_path } }
      end
    else
      campos={}
      @bloque.errors.each do |error|
        campos[error]={_set: {error: @bloque.errors[error]} }
      end
      respond_with @bloque do |format|
        format.json {render :json => { _exito: false, _canterrores: @bloque.errors.count, _campos: campos} }
      end
    end
  end
  
  def edit
    @bloque = Bloque.where(:_id => params[:id],:borrado.exists => false).first
  end
  
  def update
    @bloque = Bloque.where(:_id => params[:id],:borrado.exists => false).first
    @bloque.tmp_vars = get_tmp_vars
    if params[:bloque][:publicado] != '1'
      @bloque.unset(:publicado)
    end
    if params[:bloque][:borrado] != '1'
      params[:bloque].delete(:borrado)
    end
    if @bloque.update_attributes(params[:bloque])
      respond_with @bloque do |format|
        format.json {render :json => { _exito: true, _mensaje: 'Bloque editado exitosamente.', _ubicacion: contenido_bloques_path } }
      end
    else
      campos={}
      @bloque.errors.each do |error|
        campos[error]={_set: {error: @bloque.errors[error]} }
      end
      respond_with @bloque do |format|
        format.json {render :json => { _exito: false, _canterrores: @bloque.errors.count, _campos: campos} }
      end
    end
  end
  
end

app/controllers/contenido/elementos_controller.rb
class Contenido::ElementosController < ApplicationController
  
  before_action :authenticate_cuenta!
  before_action 'autenticar_permiso!("contenido","elementos")'
  
  def new
    @elemento_menu = Embed::ElementoMenu.new
  end
  
  def create
    @elemento_menu = Embed::ElementoMenu.new(params[:embed_elemento_menu])
    menu = Menu.where(ubicacion: params[:menu_id]).first
    unless menu
      menu = Menu.new(ubicacion: params[:menu_id])
    end
    menu.tmp_vars = get_tmp_vars
    menu.elementos << @elemento_menu
    if menu.save
      respond_with @elemento_menu do |format|
        format.json {render :json => { _exito: true, _mensaje: 'Elemento subido exitosamente.', _ubicacion: contenido_menus_path } }
      end
    else
      campos={}
      @elemento_menu.errors.each do |error|
        campos[error]={_set: {error: @elemento_menu.errors[error]} }
      end
      respond_with @elemento_menu do |format|
        format.json {render :json => { _exito: false, _canterrores: @elemento_menu.errors.count, _campos: campos} }
      end
    end
  end
  
  def edit
    menu = Menu.where(ubicacion: params[:menu_id]).first
    @elemento_menu = menu.elementos.where(_id: params[:id]).first
  end
  
  def update
    menu = Menu.where(ubicacion: params[:menu_id]).first
    menu.tmp_vars = get_tmp_vars
    @elemento_menu = menu.elementos.where(_id: params[:id]).first
    if params[:embed_elemento_menu][:borrado] != '1'
      params[:embed_elemento_menu].delete(:borrado)
    end
    if @elemento_menu.update_attributes(params[:embed_elemento_menu])
      respond_with @elemento_menu do |format|
        format.json {render :json => { _exito: true, _mensaje: 'Elemento editado exitosamente.', _ubicacion: contenido_menus_path } }
      end
    else
      campos={}
      @elemento_menu.errors.each do |error|
        campos[error]={_set: {error: @elemento_menu.errors[error]} }
      end
      respond_with @elemento_menu do |format|
        format.json {render :json => { _exito: false, _canterrores: @elemento_menu.errors.count, _campos: campos} }
      end
    end
  end
  
end

app/controllers/contenido/menus_controller.rb
class Contenido::MenusController < ApplicationController
  
  before_action :authenticate_cuenta!
  before_action 'autenticar_permiso!("contenido","menus")'
  
  def index
    render :locals => { :menu_superior => Menu.where(:ubicacion => 1).first, :menu_inferior => Menu.where(:ubicacion => 2).first }
  end
  
end

app/controllers/contenido/posts_controller.rb
class Contenido::PostsController < ApplicationController
  
  before_action :authenticate_cuenta!
  before_action 'autenticar_permiso!("contenido","posts")'
  
  def index
    render :locals => { :posts => current_cuenta.persona.posts.where( :borrado.exists => false).sort(:_id => -1) }
  end
  
  def new
    @post = Post.new
  end
    
  def create
    if params[:post][:publicado] != '1'
      params[:post].delete(:publicado)
    end
    @post = Post.new(params[:post].merge( :tmp_vars => get_tmp_vars))
    if @post.save
      respond_with @post do |format|
        format.json {render :json => { _exito: true, _mensaje: 'post subido exitosamente.', _ubicacion: contenido_posts_path } }
      end
    else
      campos={}
      @post.errors.each do |error|
        campos[error]={_set: {error: @post.errors[error]} }
      end
      respond_with @post do |format|
        format.json {render :json => { _exito: false, _canterrores: @post.errors.count, _campos: campos} }
      end
    end
  end
  
  def edit
    @post = current_cuenta.persona.posts.where(:_id => params[:id],:borrado.exists => false).first
  end
    
  def update
    @post = current_cuenta.persona.posts.where(:_id => params[:id],:borrado.exists => false).first
    @post.tmp_vars = get_tmp_vars
    if params[:post][:publicado] != '1'
      @post.unset(:publicado)
    end
    if params[:post][:borrado] != '1'
      params[:post].delete(:borrado)
    end
    if @post.update_attributes(params[:post])
      respond_with @post do |format|
        format.json {render :json => { _exito: true, _mensaje: 'Post editado exitosamente.', _ubicacion: contenido_posts_path } }
      end
    else
      campos={}
      @post.errors.each do |error|
        campos[error]={_set: {error: @post.errors[error]} }
      end
      respond_with @post do |format|
        format.json {render :json => { _exito: false, _canterrores: @post.errors.count, _campos: campos} }
      end
    end
  end
  
end

app/controllers/contenido_controller.rb
class ContenidoController < ApplicationController
  
  before_action :authenticate_cuenta!
  before_action 'autenticar_permiso!("contenido")'
  
  def index
  
  end
  
end

app/views/contenido/bloques/edit.html.erb
<% content_for :titulo_pagina do %>Contenido > Bloques > Editar<% end %>
<% content_for :titulo_bloque do %><%=link_to 'Contenido', contenido_index_path %> > <%=link_to 'Bloques', contenido_bloques_path %> > Editar<% end %>

<script type="text/javascript">
  CKEDITOR.replace('bloque_contenido')
</script>

<%= form_for @bloque, url: contenido_bloque_path(params[:id]), remote: true, html: { id: 'bloque', method: :patch, 'data-type' => :json}, :builder => FormHelper::SFormBuilder do |f| %>
  <%= f.iniciar_sformjs %>
  <%= f.resumen_errores %>
  <%= f.campo_texto :titulo, autofocus: true, autocomplete: "off" %>
  <%= f.campo_checkbox :mostrar_titulo, label: 'Mostrar título' %>
  <%= f.campo_areatexto :contenido, :label => 'Contenido', :ckeditor => {:language => 'es', :toolbar => [['Source'],
      ['Cut','Copy','Paste', 'PasteText', 'PasteFromWord','-','Undo','Redo'],['Find', 'Replace', '-', 'SelectAll'],['Scayt'],[ 'Link', 'Unlink', 'Anchor' ],['Image','Youtube'],
      ['HorizontalRule'],['Smiley', 'SpecialChar'],['CodeSnippet'],[ 'About' ],
      '/',['FontSize' ],['Bold', 'Italic','Underline','Strike', 'Subscript', 'Superscript', '-', 'RemoveFormat'],
      ['JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock'],[ 'NumberedList', 'BulletedList'],[ 'TextColor', 'BGColor' ]]} %>
  <%= f.campo_archivo :ent_archivos, :label => 'Archivos adjuntos', :ajax => true, :multiple => true %>
  <%= f.campo_checkbox :transparente, label: 'Transparente' %>
  <%= f.campo_checkbox :publicado, label: 'Publicar' %>
  <%= f.campo_selec :ubicacion, opciones: [['Seleccione',''],['Superior','sup'], ['Izquierdo','izq'], ['Derecho','der'], ['Inferior','inf']], label: 'Ubicación' %>
  <%= f.campo_numerico :posicion, autocomplete: "off" %>
  <%= f.campo_checkbox :borrado, :label => 'Eliminar', :confirmar => '¿Esta seguro que desea eliminar definitivamente este bloque?'  %>
  <%= f.boton_enviar 'enviar','Enviar','plus' %>
<% end %>

app/views/contenido/bloques/index.html.erb
<% content_for :titulo_pagina do %>Contenido > Bloques<% end %>
<% content_for :titulo_bloque do %><%= link_to 'Contenido', contenido_index_path %> > Bloques<% end %>

<%= boton_enlace 'Nuevo bloque', new_contenido_bloque_path, icono: 'plus' %>

<% unless bloques.empty? %>
  <%= rejilla ['Titulo','Ubicación','Publicado','Estado','...'] do |r| %>
    <% bloques.each do |bloque| %>
      <%= r.fila [bloque.titulo, (bloque.ubicacion == 'der' ? 'Derecho' : 'Izquierdo'), bloque.fecha_publicado ? 'hace '+time_ago_in_words(bloque.fecha_publicado, include_seconds: true):'no', ( bloque.publicado ? 'publicado' : 'no publicado' ), link_to('Editar', edit_contenido_bloque_path(bloque._id))] %>
    <% end %>
  <% end %>
<% else %>
  <div style="text-align: center; font-weight: bold; margin: 10px">No se han encontrado bloques.</div>
<% end %>

app/views/contenido/bloques/new.html.erb
<% content_for :titulo_pagina do %>Contenido > Bloques > Nuevo<% end %>
<% content_for :titulo_bloque do %><%=link_to 'Contenido', contenido_index_path %> > <%=link_to 'Bloques', contenido_bloques_path %> > Nuevo<% end %>

<script type="text/javascript">
  CKEDITOR.replace('bloque_contenido')
</script>

<%= form_for @bloque, url: contenido_bloques_path, remote: true, html: { id: 'bloque', 'data-type' => :json}, :builder => FormHelper::SFormBuilder do |f| %>
  <%= f.iniciar_sformjs %>
  <%= f.resumen_errores %>
  <%= f.campo_texto :titulo, autofocus: true, autocomplete: "off" %>
  <%= f.campo_checkbox :mostrar_titulo, label: 'Mostrar título' %>
  <%= f.campo_areatexto :contenido, :label => 'Contenido', :ckeditor => {:language => 'es', :toolbar => [['Source'],
      ['Cut','Copy','Paste', 'PasteText', 'PasteFromWord','-','Undo','Redo'],['Find', 'Replace', '-', 'SelectAll'],['Scayt'],[ 'Link', 'Unlink', 'Anchor' ],['Image','Youtube'],
      ['HorizontalRule'],['Smiley', 'SpecialChar'],['CodeSnippet'],[ 'About' ],
      '/',['FontSize' ],['Bold', 'Italic','Underline','Strike', 'Subscript', 'Superscript', '-', 'RemoveFormat'],
      ['JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock'],[ 'NumberedList', 'BulletedList'],[ 'TextColor', 'BGColor' ]]} %>
  <%= f.campo_archivo :ent_archivos, :label => 'Archivos adjuntos', :ajax => true, :multiple => true %>
  <%= f.campo_checkbox :transparente, label: 'Transparente' %>
  <%= f.campo_checkbox :publicado, label: 'Publicar' %>
  <%= f.campo_selec :ubicacion, opciones: [['Seleccione',''],['Superior','sup'], ['Izquierdo','izq'], ['Derecho','der'], ['Inferior','inf']], label: 'Ubicación' %>
  <%= f.campo_numerico :posicion, autocomplete: "off" %>
  <%= f.boton_enviar 'enviar','Enviar','plus' %>
<% end %>